#include <gint/display.h>

#include "vec.h"

void vec_cpy(Vec *destination, Vec source) {
	destination->x = source.x;
	destination->y = source.y;
}

void vec_add(Vec *vector, Vec force) {
	vector->x += force.x;
	vector->y += force.y;
}

void vec_sub(Vec *vector, Vec force) {
	vector->x -= force.x;
	vector->y -= force.y;
}

void vec_mul(Vec *vector, int scale) {
	vector->x *= scale;
	vector->y *= scale;
}

void vec_mulf(Vec *vector, float scale) {
	vector->x *= scale;
	vector->y *= scale;
}

void vec_div(Vec *vector, int scale) {
	vector->x /= scale;
	vector->y /= scale;
}

void vec_divf(Vec *vector, float scale) {
	vector->x /= scale;
	vector->y /= scale;
}

void vec_lerp(Vec *from, Vec to, float scale) {
	/* from * (1 - scale) + temp * scale */
	Vec temp;
	vec_cpy(&temp, to);
	/* from * (1 - scale) */
	vec_mulf(from, 1 - scale);
	/* temp * scale */
	vec_mulf(&temp, scale);
	/* add */
	vec_add(from, temp);
}

void vec_clamp(Vec *to_limit, Vec min, Vec max) {
	if (to_limit->x < min.x) to_limit->x = min.x;
	if (to_limit->y < min.y) to_limit->y = min.y;
	if (to_limit->x > max.x) to_limit->x = max.x;
	if (to_limit->y > max.y) to_limit->y = max.y;
}

void vec_drect(Vec top_left, Vec bottom_right, int color) {
	drect(top_left.x, top_left.y, bottom_right.x, bottom_right.y, color);
}
